/*================================================================
This demo code shows how to use the touch screen in TFT01-2.8
The LCD connection is the same as that in “16 Bit Pant Demo“
 
by Elecfreaks                                       6/28/2013
================================================================*/
#define LCD_RS   38         
#define LCD_WR   39     
#define LCD_CS   40       
#define LCD_REST 41

#define DCLK     6
#define CS       5  
#define DIN      4 
#define DOUT     3
#define IRQ      2 

unsigned int TP_X,TP_Y;
void spistar()                                     //SPI Start
{
  digitalWrite(CS,HIGH);
  digitalWrite(DCLK,HIGH);
  digitalWrite(DIN,HIGH);
  digitalWrite(DCLK,HIGH);
 
}
//**********************************************************
void WriteCharTo7843(unsigned char num)          //SPI Write Data
{
  unsigned char count=0;
  unsigned char temp;
  unsigned nop;
  temp=num;
  digitalWrite(DCLK,LOW);
  for(count=0;count<8;count++)
  {
    if(temp&0x80)
      digitalWrite(DIN,HIGH);
    else
      digitalWrite(DIN,LOW);
 
    temp=temp<<1; 
 
    digitalWrite(DCLK,LOW);                
    nop++;
    nop++;
    digitalWrite(DCLK,HIGH);
    nop++;
    nop++;
  }
}
 
//**********************************************************
unsigned int ReadFromCharFrom7843()             //SPI Read Data
{ 
  unsigned nop;
  unsigned char count=0;
  unsigned int Num=0;
  for(count=0;count<12;count++)
  {
    Num<<=1;
    digitalWrite(DCLK,HIGH);//DCLK=1; _nop_();_nop_();_nop_();                
    nop++;
    digitalWrite(DCLK,LOW);//DCLK=0; _nop_();_nop_();_nop_();
    nop++;
    if(digitalRead(DOUT)) Num++;
  }
  return(Num);
}
 
void AD7843(void)              
{
  digitalWrite(CS,LOW);                    
  WriteCharTo7843(0x90); 
  digitalWrite(DCLK,HIGH);
  digitalWrite(DCLK,LOW); 
  TP_Y=ReadFromCharFrom7843();
  WriteCharTo7843(0xD0);   
  digitalWrite(DCLK,HIGH);
  digitalWrite(DCLK,LOW);
  TP_X=ReadFromCharFrom7843();
  digitalWrite(CS,HIGH);
}
 
 
 
void Lcd_Writ_Bus(char VH,char VL)
{
  digitalWrite(LCD_CS,LOW); 
  PORTA = VH;
  PORTC = VL;
  digitalWrite(LCD_WR,LOW);
  digitalWrite(LCD_WR,HIGH);
  digitalWrite(LCD_CS,HIGH);  
}
 
 
void Lcd_Write_Com(char da)  
{   
  digitalWrite(LCD_RS,LOW);
  Lcd_Writ_Bus(da>>8, da);
}
 
void Lcd_Write_Data(char VH,char VL)
{
  digitalWrite(LCD_RS,HIGH);
  Lcd_Writ_Bus(VH,VL);
}
 
void Lcd_Write_Com_Data(int com,int dat)
{
     Lcd_Write_Com(com);
     Lcd_Write_Data(dat>>8, dat);
}
 
void Address_set(unsigned int x1,unsigned int y1,unsigned int x2,unsigned int y2)
{   
      Lcd_Write_Com(0x0020);Lcd_Write_Data(x1>>8,x1);	  //设置X坐标位置
      Lcd_Write_Com(0x0021);Lcd_Write_Data(y1>>8,y1);     //设置Y坐标位置
      Lcd_Write_Com(0x0050);Lcd_Write_Data(x1>>8,x1);     //开始X
      Lcd_Write_Com(0x0052);Lcd_Write_Data(y1>>8,y1);	  //开始Y
      Lcd_Write_Com(0x0051);Lcd_Write_Data(x2>>8,x2);     //结束X
      Lcd_Write_Com(0x0053);Lcd_Write_Data(y2>>8,y2);     //结束Y
      Lcd_Write_Com(0x0022);							 
}
 
void Lcd_Init(void)
{
       digitalWrite(LCD_REST,HIGH);
       delay(5); 
       digitalWrite(LCD_REST,LOW);
       delay(15);
       digitalWrite(LCD_REST,HIGH);
       delay(15);
       
       Lcd_Write_Com_Data(0x0001,0x0100); 
       Lcd_Write_Com_Data(0x0002,0x0700); 
       Lcd_Write_Com_Data(0x0003,0x1030); 
       Lcd_Write_Com_Data(0x0004,0x0000); 
       Lcd_Write_Com_Data(0x0008,0x0207);  
       Lcd_Write_Com_Data(0x0009,0x0000);
       Lcd_Write_Com_Data(0x000A,0x0000); 
       Lcd_Write_Com_Data(0x000C,0x0000); 
       Lcd_Write_Com_Data(0x000D,0x0000);
       Lcd_Write_Com_Data(0x000F,0x0000);
      //power on sequence VGHVGL
       Lcd_Write_Com_Data(0x0010,0x0000);   
       Lcd_Write_Com_Data(0x0011,0x0007);  
       Lcd_Write_Com_Data(0x0012,0x0000);  
       Lcd_Write_Com_Data(0x0013,0x0000); 
      //vgh 
       Lcd_Write_Com_Data(0x0010,0x1290);   
       Lcd_Write_Com_Data(0x0011,0x0227);
       //delayms(100);
       //vregiout 
       Lcd_Write_Com_Data(0x0012,0x001d); //0x001b
       //delayms(100); 
       //vom amplitude
       Lcd_Write_Com_Data(0x0013,0x1500);
       //delayms(100); 
       //vom H
       Lcd_Write_Com_Data(0x0029,0x0018); 
       Lcd_Write_Com_Data(0x002B,0x000D); 
      
      //gamma
       Lcd_Write_Com_Data(0x0030,0x0004);
       Lcd_Write_Com_Data(0x0031,0x0307);
       Lcd_Write_Com_Data(0x0032,0x0002);// 0006
       Lcd_Write_Com_Data(0x0035,0x0206);
       Lcd_Write_Com_Data(0x0036,0x0408);
       Lcd_Write_Com_Data(0x0037,0x0507); 
       Lcd_Write_Com_Data(0x0038,0x0204);//0200
       Lcd_Write_Com_Data(0x0039,0x0707); 
       Lcd_Write_Com_Data(0x003C,0x0405);// 0504
       Lcd_Write_Com_Data(0x003D,0x0F02); 
       //ram
       Lcd_Write_Com_Data(0x0050,0x0000); 
       Lcd_Write_Com_Data(0x0051,0x00EF);
       Lcd_Write_Com_Data(0x0052,0x0000); 
       Lcd_Write_Com_Data(0x0053,0x013F);  
       Lcd_Write_Com_Data(0x0060,0xA700); 
       Lcd_Write_Com_Data(0x0061,0x0001); 
       Lcd_Write_Com_Data(0x006A,0x0000); 
       //
       Lcd_Write_Com_Data(0x0080,0x0000); 
       Lcd_Write_Com_Data(0x0081,0x0000); 
       Lcd_Write_Com_Data(0x0082,0x0000); 
       Lcd_Write_Com_Data(0x0083,0x0000); 
       Lcd_Write_Com_Data(0x0084,0x0000); 
       Lcd_Write_Com_Data(0x0085,0x0000); 
       //
       Lcd_Write_Com_Data(0x0090,0x0010); 
       Lcd_Write_Com_Data(0x0092,0x0600); 
       Lcd_Write_Com_Data(0x0093,0x0003); 
       Lcd_Write_Com_Data(0x0095,0x0110); 
       Lcd_Write_Com_Data(0x0097,0x0000); 
       Lcd_Write_Com_Data(0x0098,0x0000);
       Lcd_Write_Com_Data(0x0007,0x0133);
 
}
 
void Pant(char VH,char VL)
{
  int i,j;

  Address_set(0,0,239,319);
  for(i=0;i<320;i++)
  {
    for (j=0;j<240;j++)
    {
      Lcd_Write_Data(VH,VL);
    }
 
  }
}
 
void setup()
{
  for(int p=22;p<42;p++)
  {
    pinMode(p,OUTPUT);
  }
  for(int p=2; p<7;p++)
      pinMode(p,OUTPUT);
  pinMode(DOUT,INPUT);
  pinMode(IRQ,INPUT);
 
  Lcd_Init();         
  Pant(0x00, 0x00);
  delay(500); 
}
 
void loop()
{
  unsigned char flag;
  unsigned char ss[6];	
  unsigned int lx,ly;
  spistar();  
  int pacy=random(0, 7);  
  while(digitalRead(IRQ)==0)
  {  	
      digitalWrite(LCD_CS,LOW); 
      AD7843();
      lx=240-((TP_X-340)*10/144);
      if(lx>237) lx=237;
      ly=320-((TP_Y-320)/11);
      if(ly<0) ly=0;
      Address_set(lx,ly,lx+2,ly+2);
      switch(pacy)
                                {
                                  case 0: for(int i=0; i<5; i++)  Lcd_Write_Data(0xF8,0x00);  break;   //Red
                                  case 1: for(int i=0; i<5; i++)  Lcd_Write_Data(0xFF,0xE0);  break;   //Yellow
                                  case 2: for(int i=0; i<5; i++)  Lcd_Write_Data(0xFF,0xFF);  break;   //White 
                                  case 3: for(int i=0; i<5; i++)  Lcd_Write_Data(0x05,0x1F);  break;   //Blue
                                  case 4: for(int i=0; i<5; i++)  Lcd_Write_Data(0x00,0x1F);  break;   //Blue-2
                                  case 5: for(int i=0; i<5; i++)  Lcd_Write_Data(0xF8,0x1F);  break;   //Magenta
                                  case 6: for(int i=0; i<5; i++)  Lcd_Write_Data(0x07,0xE0);  break;   //Green
                                  case 7: for(int i=0; i<5; i++)  Lcd_Write_Data(0x7F,0xFF);  break;   //Cyan
                                  defoult:for(int i=0; i<5; i++)  Lcd_Write_Data(0x00,0x00);  break;   //Black
                                }
      digitalWrite(LCD_CS,HIGH); 
    }
}
